package com.xinelu.manage.mapper.specialdiseaseroute;

import com.xinelu.manage.domain.specialdiseaseroute.SpecialDiseaseRoute;
import com.xinelu.manage.dto.specialdiseaseroute.SpecialDiseaseRouteDTO;
import com.xinelu.manage.vo.department.DepartmentVO;
import com.xinelu.manage.vo.specialdiseaseroute.*;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 专病路径信息Mapper接口
 *
 * @author xinelu
 * @date 2024-03-13
 */
public interface SpecialDiseaseRouteMapper {
    /**
     * 查询专病路径信息
     *
     * @param id 专病路径信息主键
     * @return 专病路径信息
     */
    SpecialDiseaseRoute selectSpecialDiseaseRouteById(Long id);

    /**
     * 查询专病路径信息列表
     *
     * @param specialDiseaseRoute 专病路径信息
     * @return 专病路径信息集合
     */
    List<SpecialDiseaseRoute> selectSpecialDiseaseRouteList(SpecialDiseaseRoute specialDiseaseRoute);

	/**
	 * 查询主路径及子路径列表
	 * @param id 专病路径信息主键
	 * @return
	 */
	List<SpecialDiseaseRoute> selectRouteAndChildren(Long id);
    /**
     * 查询专病路径信息列表
     *
     * @param specialDiseaseRoute 专病路径信息
     * @return 专病路径信息集合
     */
    List<SpecialDiseaseRouteVO> selectDiseaseRouteList(SpecialDiseaseRouteDTO specialDiseaseRoute);

	SpecialDiseaseRouteAuditVo getRouteAuditInfo(Long routeId);

	List<SpecialDiseaseChildRouteAuditVo> selectAuditChildRoute(Long parentRouteId);

    /**
     * 新增专病路径信息
     *
     * @param specialDiseaseRoute 专病路径信息
     * @return 结果
     */
    int insertSpecialDiseaseRoute(SpecialDiseaseRoute specialDiseaseRoute);

    /**
     * 修改专病路径信息
     *
     * @param specialDiseaseRoute 专病路径信息
     * @return 结果
     */
    int updateSpecialDiseaseRoute(SpecialDiseaseRoute specialDiseaseRoute);

    /**
     * 删除专病路径信息
     *
     * @param id 专病路径信息主键
     * @return 结果
     */
    int deleteSpecialDiseaseRouteById(Long id);

    /**
     * 批量删除专病路径信息
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteSpecialDiseaseRouteByIds(Long[] ids);

    /**
     * 科室路径数量
     *
     * @param specialDiseaseRouteQueryDto 查询条件
     * @return DepartmentVO
     */
    List<DepartmentVO> departmentRouteByDepartmentName(SpecialDiseaseRouteDTO specialDiseaseRouteQueryDto);

    /**
     * 查询专病路径信息
     *
     * @param id 专病路径信息主键
     * @return 专病路径信息
     */
    SpecialDiseaseRouteVO selectSpecialDiseaseRouteAndTriggerById(Long id);

	/**
	 * 查询专病管理路径及子路径信息
	 * @param id 专病路径信息主键
	 * @return 专病管理路径及子路径信息
	 */
	SpecialDiseaseRouteInfoVo getRouteAndChild(@Param("id") Long id);

	/**
	 * 查询子路径
	 * @param specialDiseaseRouteId 专病路径信息主键
	 * @return
	 */
	List<SpecialDiseaseRouteInfoVo> getChildList(@Param("specialDiseaseRouteId")Long specialDiseaseRouteId);

    /**
     * 查询未审核节点状态
     *
     * @param routeId 路径信息
     * @return int
     */
    List<String> selectRouteCheckStatus(Long routeId);

    /**
     * 根据科室及路径名称查询信息
     *
     * @param departmentId
     * @param routeName
     * @return
     */
    List<SpecialDiseaseRoute> selectCountByName(@Param("departmentId") Long departmentId, @Param("routeName") String routeName);

    /**
     * 查询子节点路径
     *
     * @param specialDiseaseRouteId 路径id
     * @return OriginalSpecialDiseaseRoute
     */
    List<OriginalSpecialDiseaseRoute> getChildSpecialDiseaseRoute(Long specialDiseaseRouteId);

    /**
     * 新增子节点路径
     *
     * @param specialDiseaseRoutes 节点信息
     * @return int
     */
    int insertSpecialDiseaseRouteList(List<OriginalSpecialDiseaseRoute> specialDiseaseRoutes);
}
